function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var Toastify = _interopDefault(require('toastify-js'));
require('toastify-js/src/toastify.css');
var Popover = _interopDefault(require('react-tiny-popover'));
require('localforage');
var styled = _interopDefault(require('styled-components'));

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

function _templateObject5() {
  var data = _taggedTemplateLiteralLoose(["\n  color: #000;\n  z-index: 1000;\n  margin-bottom: 5px;\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteralLoose(["\n  background-color: #fff;\n  border-radius: 5px;\n  border: 1px solid #eaeaea;\n  box-shadow: 0 0 5px 1px rgba(0,0,0,0.1);\n  padding: 10px;\n  font-size: 14px;\n  display: flex;\n  flex-direction: column;\n  z-index: 999;\n  opacity: 0.7;\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteralLoose(["\n  position: relative;\n  border-radius: 5px;\n  border: 2px solid #eaeaea;\n  padding: 10px;\n  \n  &:hover {\n    cursor: pointer;\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteralLoose(["\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  position: absolute;\n  border-radius: 50%;\n  top: -25px;\n  right: -25px;\n  width: 32px;\n  height: 32px;\n  color: #fff;\n\n  &.log {\n    background-color: #b9b9b9;\n  }\n\n  &.error {\n    background-color: #ff4242;\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n  position: absolute;\n  background-color: #fff;\n  left: 20px;\n  bottom: 20px;\n  display: flex;\n  justify-content: space-around;\n  width: 200px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Wrapper = styled.div(_templateObject());
var Badge = styled.div(_templateObject2());
var Console = styled.div(_templateObject3());
var PopoverBody = styled.div(_templateObject4());
var PopoverItem = styled.div(_templateObject5());

var Toaster = function Toaster(_ref) {
  var _ref$position = _ref.position,
      position = _ref$position === void 0 ? 'bottom' : _ref$position,
      _ref$duration = _ref.duration,
      duration = _ref$duration === void 0 ? '4000' : _ref$duration,
      destination = _ref.destination,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? '' : _ref$className;

  var _useState = React.useState(0),
      logCount = _useState[0],
      setLogCount = _useState[1];

  var _useState2 = React.useState([]),
      logInfo = _useState2[0],
      setLogInfo = _useState2[1];

  var _useState3 = React.useState(false),
      openLog = _useState3[0],
      setOpenLog = _useState3[1];

  var _useState4 = React.useState(0),
      errorCount = _useState4[0],
      setErrorCount = _useState4[1];

  var _useState5 = React.useState([]),
      errorInfo = _useState5[0],
      setErrorInfo = _useState5[1];

  var _useState6 = React.useState(false),
      openError = _useState6[0],
      setOpenError = _useState6[1];

  React.useEffect(function () {
    if (window.console && console) {

      console.log = function (args) {
        Toastify({
          text: args,
          gravity: position,
          stopOnFocus: true,
          duration: duration,
          className: className,
          newWindow: true,
          destination: destination || "https://google.com/search?q=" + args
        }).showToast();
        setLogCount(function (prevCount) {
          return prevCount + 1;
        });
        var newLogInfo = logInfo;
        newLogInfo.push({
          info: args,
          date: new Date(Date.now()).toISOString()
        });
        setLogInfo(newLogInfo);
      };

      console.error = function (args) {
        Toastify({
          text: args,
          gravity: position,
          stopOnFocus: true,
          duration: duration,
          className: className,
          newWindow: true,
          destination: destination || "https://google.com/search?q=" + args
        }).showToast();
        setErrorCount(function (prevCount) {
          return prevCount + 1;
        });
        var newErrorInfo = errorInfo;
        newErrorInfo.push({
          info: args,
          date: new Date(Date.now()).toISOString()
        });
        setErrorInfo(newErrorInfo);
      };
    }
  }, []);
  return /*#__PURE__*/React__default.createElement(Wrapper, null, /*#__PURE__*/React__default.createElement(Popover, {
    isOpen: openLog,
    position: 'top',
    onClickOutside: function onClickOutside() {
      return setOpenLog(false);
    },
    content: /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement(PopoverBody, null, logInfo.length > 0 ? logInfo.map(function (item, index) {
      return /*#__PURE__*/React__default.createElement(PopoverItem, {
        key: index
      }, /*#__PURE__*/React__default.createElement("b", null, index + 1), " - [", item.date, "] - ", item.info);
    }) : /*#__PURE__*/React__default.createElement(PopoverItem, null, "No console.log() yet")))
  }, function (ref) {
    return /*#__PURE__*/React__default.createElement(Console, {
      ref: ref,
      className: "log",
      onClick: function onClick() {
        return setOpenLog(!openLog);
      }
    }, "log", /*#__PURE__*/React__default.createElement(Badge, {
      className: "log"
    }, logCount));
  }), /*#__PURE__*/React__default.createElement(Popover, {
    isOpen: openError,
    position: 'top',
    onClickOutside: function onClickOutside() {
      return setOpenError(false);
    },
    content: /*#__PURE__*/React__default.createElement("div", null, /*#__PURE__*/React__default.createElement(PopoverBody, null, errorInfo.length > 0 ? errorInfo.map(function (item, index) {
      return /*#__PURE__*/React__default.createElement(PopoverItem, {
        key: index
      }, /*#__PURE__*/React__default.createElement("b", null, index + 1), " - [", item.date, "] - ", item.info);
    }) : /*#__PURE__*/React__default.createElement(PopoverItem, null, "No console.error() yet")))
  }, function (ref) {
    return /*#__PURE__*/React__default.createElement(Console, {
      ref: ref,
      className: "error",
      onClick: function onClick() {
        return setOpenError(!openError);
      }
    }, "error", /*#__PURE__*/React__default.createElement(Badge, {
      className: "error"
    }, errorCount));
  }));
};

module.exports = Toaster;
//# sourceMappingURL=index.js.map
